---
title: Navigator.sendBeacon()
slug: Web/API/Navigator/sendBeacon
tags:
  - API
  - Beacon
  - Method
  - Navigator
  - NeedsExample
  - Networking
  - Reference
  - Web Performance
  - sendBeacon
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The <code><strong>navigator.sendBeacon()</strong></code> method {{glossary("Asynchronous", "asynchronously")}} sends a small amount of data over {{Glossary("HTTP")}} to a web server.</span> It’s intended to be used in combination with the <code><a href="/en-US/docs/Web/API/Document/visibilitychange_event">visibilitychange</a></code> event (but not with the <code><a href="/en-US/docs/Web/API/Window/unload_event">unload</a></code> and <code><a href="/en-US/docs/Web/API/Window/beforeunload_event">beforeunload</a></code> events).</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">navigator.sendBeacon(<var>url</var>, <var>data</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>url</var></code></dt>
 <dd>The URL that will receive the <var>data</var>. Can be relative or absolute.</dd>
 <dt><code><var>data</var></code></dt>
 <dd>A {{domxref("ArrayBuffer")}}, {{domxref("ArrayBufferView")}}, {{domxref("Blob")}}, {{domxref("DOMString")}}, {{domxref("FormData")}}, or {{domxref("URLSearchParams")}} object containing the data to send.</dd>
</dl>

<h3 id="Return_values">Return values</h3>

<p>The <code><strong>sendBeacon()</strong></code> method returns <code>true</code> if the {{glossary("user agent")}} successfully queued the <code>data</code> for transfer. Otherwise, it returns <code>false</code>.</p>

<h2 id="Description">Description</h2>

<p>This method is for analytics and diagnostics that send data to a server before the document is unloaded, where sending the data any sooner may miss some possible data collection. For example, which link the user clicked before navigating away and unloading the page.</p>

<p>Ensuring that data has been sent during the unloading of a document has traditionally been difficult, because user agents typically ignore asynchronous {{domxref("XMLHttpRequest")}}s made in an {{domxref("Window/unload_event", "unload")}} handler.</p>

<p>Historically, this was addressed with some of the following workarounds to delay the page unload long enough to send data to some URL:</p>

<ul>
 <li>Submitting the data with a blocking synchronous <code>XMLHttpRequest</code> call in <code>unload</code> or {{domxref("Window/beforeunload_event", "beforeunload")}} event handlers.</li>
 <li>Creating an {{HTMLElement("img")}} element and setting its <code>src</code> in the <code>unload</code> handler. Most user agents will delay the unload to load the image.</li>
 <li>Creating a no-op loop for several seconds in the <code>unload</code> handler.</li>
</ul>

<p>All of these methods block unloading the document, which slows down the next navigation. There is nothing the next page can do to avoid this, so the new page seems slow, even though it's the previous page's fault.</p>

<p>The following example shows theoretical analytics code that attempts to submit data to a server with a synchronous <code>XMLHttpRequest</code> in an <code>unload</code> handler. This results in the next page load to be delayed.</p>

<pre class="brush: js notranslate">window.addEventListener("unload", function logData() {
  var xhr = new XMLHttpRequest();
  xhr.open("POST", "/log", false); // third parameter of `false` means synchronous
  xhr.send(analyticsData);
});
</pre>

<p>This is what <code><strong>sendBeacon()</strong></code> replaces. With the <code>sendBeacon()</code> method, the data is transmitted asynchronously when the User Agent has an opportunity to do so, without delaying unload or the next navigation. <strong>This solves all of the problems with submission of analytics data:</strong></p>

<ul>
 <li>The data is sent reliably</li>
 <li>It's sent asynchronously</li>
 <li>It doesn't impact the loading of the next page</li>
 <li>In addition, the code is simpler to write than any of the older techniques!</li>
</ul>

<div class="notecard warning">
<p><code><a href="/en-US/docs/Web/API/Window/unload_event">unload</a></code> and <code><a href="/en-US/docs/Web/API/Window/beforeunload_event">beforeunload</a></code> aren’t the right events to use with <code>sendBeacon</code>. Instead, use <code><a href="/en-US/docs/Web/API/Document/visibilitychange_event">visibilitychange</a></code>. See discussion in the comments at <a href="https://volument.com/blog/sendbeacon-is-broken#comments">Beacon API is broken</a> — and especially see the article at <a href="https://www.igvita.com/2015/11/20/dont-lose-user-and-app-state-use-page-visibility/">Don't lose user and app state, use Page Visibility</a>, which explains: <em>Use Page Visibility API and execute its session save-and-restore logic whenever <code>visibilitychange</code> state changes… forget that the other events even exist. Treat every transition to visible as a new session: restore previous state, reset your analytics counters, and so on. Then, when the application transitions to <code>hidden</code>, end the session: save user and app state, beacon your analytics, and perform all other necessary work.</em></p>

<p>You can use the <a href="https://github.com/GoogleChromeLabs/page-lifecycle">PageLifecycle.js</a> library to deal with current cross-browser inconsistencies in handling of the <code><a href="/en-US/docs/Web/API/Document/visibilitychange_event">visibilitychange</a></code> event and other related behavior; that library normalizes cross-browser differences in event-firing order so that state changes always occur exactly as expected, consistently in all browsers.</p>

<p>For additional best-practices guidance in detail, see the <a href="https://developers.google.com/web/updates/2018/07/page-lifecycle-api#developer-recommendations-for-each-state">Page Lifecycle API</a> how-to article.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Beacon', '#sendbeacon-method', 'sendBeacon()')}}</td>
   <td>{{Spec2('Beacon')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Navigator.sendBeacon")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.igvita.com/2015/11/20/dont-lose-user-and-app-state-use-page-visibility/">Don't lose user and app state, use Page Visibility</a> is an article which explains in detail why you should use <code>visibilitychange</code>, not <code>beforeunload</code>/<code>unload</code>:<br>
  <em>Use Page Visibility API and execute its session save-and-restore logic whenever <code>visibilitychange</code> state changes. This is the only event your application can count on… forget that the other events even exist. Treat every transition to visible as a new session: restore previous state, reset your analytics counters, and so on. Then, when the application transitions to <code>hidden</code>, end the session: save user and app state, beacon your analytics, and perform all other necessary work.</em></li>
 <li><a href="https://developers.google.com/web/updates/2018/07/page-lifecycle-api#developer-recommendations-for-each-state">Page Lifecycle API</a> is a how-to article that gives best-practices guidance on handling page-lifecyle behavior in your web applications.</li>
 <li><a href="https://github.com/GoogleChromeLabs/page-lifecycle">PageLifecycle.js</a> is a JavaScript library (&lt;1K gzipped) that deals with cross-browser inconsistencies in page-lifecyle behavior, enabling you to focus on following the best-practices guidance in the <a href="https://developers.google.com/web/updates/2018/07/page-lifecycle-api#developer-recommendations-for-each-state">Page Lifecycle API</a> article. It normalizes cross-browser differences in event-firing order so that state changes always occur exactly as outlined in the chart and tables in that article (and do so consistently in all browsers).</li>
</ul>
